/*
	ProWesS, PROGS Windowing System

	dynamic configurator program for ProWesS

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 04 October 1995
*/

#include "io_h"
#include "str_h"
#include "dir_h"

#include "ProWesS_h"

static char info[]={"This program allow directory structures to\n"
					"be copied. All subdirectories of the given\n"
					"source directory will be subdirectories of\n"
					"the destination."};
static char t[]={"ProWess Config"};

typedef struct {
	PWObject source,dest;
	} Global;

Error copy(PWObject obj)
{
  return ERR_OK;
}

void init()
{
	PWObject obj;
	PWObject ment;
	Global g;

	PWCreate(NULL,&obj,PW_TYPE_OUTLINE,
				PW_OUTLINE_SLEEP,
				PW_OUTLINE_SLEEP_TEXT,t,
				PW_OUTLINE_QUIT,
				PW_OUTLINE_QUIT_KEYPRESS, 27,
				PW_OUTLINE_TITLE_TEXT,t,
				NULL);
	PWCreate(obj,&g.source,PW_TYPE_EDLINE,
				PW_EDLINE_MAXLENGTH, 20,
				PW_EDLINE_SET,t,
				PW_EDLINE_ACTION_AFTER,copy,
				NULL);

	PWCreate(obj,NULL,PW_TYPE_LABEL,
/*				  PW_POSITION_LEFT_OF, g.source, */
				PW_SCALE_FACTOR, 0,
				PW_LABEL_TEXT, t,
				NULL);

	PWCreate(obj,NULL,PW_TYPE_SEPARATOR,
				PW_POSITION_BELOW, g.source,
				NULL);

	PWCreate(obj,&ment,PW_TYPE_MENU,
				PW_MENU_ITEMWIDTH_PIX,480,
				PW_MENU_VISIBLE_LINES,25,
				PW_MENU_UNIQUE,
				NULL);


	PWActivate(obj);


}
