# 1 "type_colselect_c"
 









# 1 "pth1_include_mem_h" 1



 








# 1 "pth1_include_sms_h" 1



 








# 1 "pth1_include_err_h" 1



 







typedef int Error;






























Error ERRMessageGet(Error err, char *message);








# 13 "pth1_include_sms_h" 2












 



























 








typedef int Size;



typedef long Job;					 

typedef unsigned short BaudRate;
typedef unsigned short Duration;
typedef unsigned char Pitch;




Error SMSVersion(char *version);
Error SMSBaud(BaudRate baudrate);
Error SMSBeep(Duration duration, Pitch pitch);
Error SMSRandom(int *result);
Error SMSRandomSeed(int newseed);
void SMSBreakSoft();
void SMSBreakHard();


# 13 "pth1_include_mem_h" 2


Error MEMAllocate(Size size, void **base);
Error MEMAllocateFor(Size size, Job id, void **base);
Error MEMRelease(void *base);
Error MEMWhenZapped(void *base, void (*ZapRoutine)(void *base), char *ZapAddress);

typedef long Chunks;	 
						 
						 
						 

Error MEMUserInit(Size BlockSize, int BlockingFactor, Chunks *id);
Error MEMUserAllocate(Chunks id, void **base);
Error MEMUserRelease(Chunks id, void *base);
Error MEMUserZap(Chunks id);
Error MEMUserWhenZapped(Chunks id, void (*ZapRoutine)(void *base), char *ZapAddress);

typedef long Heap;		 
Error MEMHeapInit(Size BlockSize, Heap *id);
Error MEMHeapAllocate(Heap id, Size size, void **base);
Error MEMHeapRelease(Heap id, void *base);
Error MEMHeapZap(Heap id);
Error MEMHeapWhenZapped(Heap id, void (*ZapRoutine)(void *base), char *ZapAddress);

Error MEMFree(Size *result);
Error MEMLargest(Size *result);

Error MEMCopy(Size size, void *from, void *to);
Error MEMClear(Size size, void *base);
int MEMSame(Size size, void *area1, void *area2);
Error MEMDuplicate(Size size, void *area, void **base);
Error MEMSearch(char byte, Size leng, void *base, void **at);
Error MEMSwap(Size size, void *base1, void *base2);

char MEMValid(void *x);



# 11 "type_colselect_c" 2

# 1 "pth1_include_dir_h" 1



 








# 1 "pth1_include_io_h" 1



 








# 1 "pth1_include_sms_h" 1
# 83 "pth1_include_sms_h"

# 13 "pth1_include_io_h" 2

# 1 "pth1_include_time_h" 1



 








typedef unsigned long Time;

# 1 "pth1_include_str_h" 1



 








# 1 "pth1_include_err_h" 1
# 51 "pth1_include_err_h"

# 13 "pth1_include_str_h" 2

# 1 "pth1_include_mem_h" 1
# 51 "pth1_include_mem_h"

# 14 "pth1_include_str_h" 2

# 1 "pth1_include_time_h" 1
# 34 "pth1_include_time_h"

# 15 "pth1_include_str_h" 2



int strlen(char *string);

Error STRLength(char *string, int *length);
Error STRCopy(char *from, char *to);
Error STRCopySafe(char *from, char *to, Size buffsize);
Error STRAppend(char *string, char *to);
Error STRAppendSafe(char *string, char *to, Size buffsize);
Error STRCompareCD(char *string, char *with, int *result);
Error STRCompareCI(char *string, char *with, int *result);
int STRSameCD(char *string1, char *string2);

int STRSameCI(char *string1, char *string2);
Error STRSearchCD(char *string, char *in, char **at);
Error STRSearchCI(char *string, char *in, char **at);
Error STRUpper(char *string);
Error STRLower(char *string);
Error STRBreak(char *string, char *(*list[]));
Error STRDuplicate(char *string, char **base);


Error STRFormatGet(char *string, int *count, char *format, ...);
Error STRFormatPut(char *string, char *format, ...);
Error STRFormatPutSafe(char *string, Size buffsize, char *format, ...);

Error STRTime(Time time, char *string);
Error STRDay(Time time, char *string);


# 15 "pth1_include_time_h" 2


typedef struct {
	int year, month, day;
	int hour, minutes, seconds;
	} SplitTime;

Error TIMEGet(Time *time);
Error TIMESet(Time time);
Error TIMEAdjust(int diff);

Error TIMESplit(Time time, SplitTime *res);
Error TIMEBuild(SplitTime *time, Time *res);

Error TIMEString(Time time, char *string);

Error TIMEDay(Time time, char *string);



# 14 "pth1_include_io_h" 2


typedef int Channel;				 











typedef short TimeOut;				 

 




typedef short OpenKey;				 







									 




typedef int FileVersion;			 







 
typedef signed char FileType;

typedef struct {
	char name[	38			];			 
	Size length;					 
	FileType type;					 
	Size dataspace; 				 
	Time UpdateTime;				 
	Time BackupTime;				 
	FileVersion version;			 
	} FileInfo;











typedef struct {
	char mediumname[22 		];	 
	char devicename[8			];	 
	char readonly;					 
	Size unitsize;					 
	Size mediumsize;				 
	Size mediumfree;				 
	char formattype, formatsubtype;  
	char density;					 
	char mediumtype;				 
	char removable; 				 
	char unused[15];				 
	} MediumInfo;


Error IOOpen(char *name, OpenKey key, Channel *id);
Error IOOpenFor(char *name, OpenKey key, Job id, Channel *ret);
Error IOOpenPath(char *name, OpenKey key, char *path, Channel *ret);

Error IOOpenPathFor(char *name, OpenKey key, Job id, char *path, Channel *ret);
Error IOClose(Channel);
Error IOFormat(char *name, int *good, int *total);
Error IODelete(char *name);

Error IOGet(Channel id, char *ret);
Error IOPut(Channel id, char value);
Error IOGetBytes(Channel id, int count, char *place, int *got);
Error IOPutBytes(Channel id, int count, char *bytes, int *sent);
Error IOGetString(Channel id, char *string, Size buffsize);
Error IOPutString(Channel id, char *string, int *sent);
Error IOPutRawBytes(Channel id, int count, char *bytes, int *sent);

Error IOTest(Channel);
Error IODone(Channel);
Error IOFlush(Channel);
Error IOTruncate(Channel);

Error IOTimeOutSet(Channel id, TimeOut t);
Error IOTimeOutGet(Channel id, TimeOut *t);
Error IOPutStringAddNewLineGet(Channel id, char *status);
Error IOPutStringAddNewLineSet(Channel id, char status);

Error IOPositionGet(Channel id, int *position);
Error IOPositionSet(Channel id, int position);
Error IOPositionMove(Channel id, int position);

Error IOFileLoad(Channel id, Size length, void *base);
Error IOFileSave(Channel id, Size length, void *base);

Error IOMedium(Channel id, MediumInfo *info);
Error IORename(Channel id, char *to);

Error IOName(Channel id, char *name, char *directory);
Error IOLength(Channel id, Size *length);
Error IOUpdateTimeGet(Channel id, Time *result);
Error IOUpdateTimeSet(Channel id, Time value);
Error IOBackupTimeGet(Channel id, Time *result);
Error IOBackupTimeSet(Channel id, Time value);
Error IOVersionGet(Channel id, FileVersion *result);
Error IOVersionSet(Channel id, FileVersion value);
Error IOFileTypeGet(Channel id, FileType *type);
Error IOFileTypeSet(Channel id, FileType type);
Error IODataSpaceGet(Channel id, Size *result);
Error IODataSpaceSet(Channel id, Size dataspace);
Error IOFileInfoGet(Channel id, FileInfo *info);
Error IOFileInfoSet(Channel id, FileInfo *info);

Error IOMakeDirectory(char *directory);


# 13 "pth1_include_dir_h" 2


typedef long DirIterator;	 

Error DIROpen(char *directory, char tree, DirIterator *iterator, ...);
Error DIRDirectory(DirIterator iterator, char *directory);
Error DIRNext(DirIterator iterator, FileInfo *result);
Error DIRClose(DirIterator iterator);
	 
	 
	 
	 
	 
	 
	 
	 

Error DIRSubOpen(char *directory, char tree, DirIterator *iterator);
Error DIRSubDirectory(DirIterator iterator, char *directory);

Error DIRSubNext(DirIterator iterator, FileInfo *result);

Error DIRSubClose(DirIterator iterator);

	 

Error DIRSieveLength(FileInfo *file, int parameter);
Error DIRSieveLengthLarger(FileInfo *file, int parameter);
Error DIRSieveLengthSmaller(FileInfo *file, int parameter);
Error DIRSieveType(FileInfo *file, int parameter);
Error DIRSieveExtension(FileInfo *file, int parameter);
Error DIRSieveExtensionNot(FileInfo *file, int parameter);


# 12 "type_colselect_c" 2

# 1 "pth1_include_str_h" 1
# 45 "pth1_include_str_h"

# 13 "type_colselect_c" 2

# 1 "pth1_include_dev_h" 1



 








# 1 "pth1_include_err_h" 1
# 51 "pth1_include_err_h"

# 13 "pth1_include_dev_h" 2




Error DEVDataGet(char *result);
Error DEVDataSet(char *dev);
Error DEVDataUp();
Error DEVDataDown(char *dir);
Error DEVProgramGet(char *result);
Error DEVProgramSet(char *dev);
Error DEVProgramUp();
Error DEVProgramDown(char *dir);
Error DEVDestinationGet(char *result);
Error DEVDestinationSet(char *dev);


# 14 "type_colselect_c" 2

# 1 "pth1_include_ctype_h" 1












extern char * _ctype;	 
extern char * _cupper;	 
extern char * _clower;	 

int isalpha(char);

int isupper(char);

int islower(char);

int isdigit(char);

int isxdigit(char);

int isspace(char);

int ispunct(char);

int isalnum(char);

int isprint(char);

int iscntrl(char);


char tolower(char);

char toupper(char);



# 15 "type_colselect_c" 2


# 1 "PWHandler_h" 1



 










# 1 "ProWesS_h" 1



 









# 1 "pth1_include_sms_h" 1
# 83 "pth1_include_sms_h"

# 14 "ProWesS_h" 2

# 1 "pth1_include_err_h" 1
# 51 "pth1_include_err_h"

# 15 "ProWesS_h" 2



# 1 "pth1_include_PROforma_h" 1



 







 







# 1 "pth1_include_err_h" 1
# 51 "pth1_include_err_h"

# 20 "pth1_include_PROforma_h" 2

# 1 "pth1_include_io_h" 1
# 148 "pth1_include_io_h"

# 21 "pth1_include_PROforma_h" 2


typedef long pt;









 























 






 
pt fixmul(pt x, pt y);	 
pt fixdiv(pt x, pt y);	 
pt fixsqrt(pt x);		 
pt fixdist(pt a, pt b);  

 






 






 






























 



 


typedef struct _Gstate *Gstate;

typedef struct { pt red, green, blue; } ColourRGB;
typedef struct { pt cyan, magenta, yellow, black; } ColourCMYK;

typedef struct { pt xsiz, ysiz, xorg, yorg; } Bbox;
typedef struct { pt xsiz, ysiz, xorg, yorg, xporg, yporg; } PageBbox;
typedef struct { short xsiz, ysiz, xorg, yorg; } PBbox;
typedef struct { short xsiz, ysiz, xorg, yorg;
				 pt xporg, yporg; } PPageBbox;

typedef struct {
	short code;
	char *name;
} CharName;

extern short *PFASCII2UnicodeTable;
extern CharName *PFCharNameTable;

void  LinkPROforma			();

Error PFGstateInit			(int, const char *, const Bbox *, Gstate *, int *);
Error PFGstateRemove		(Gstate);
Error PFGstateSave			(Gstate);
Error PFGstateRestore		(Gstate);

Error PFLineWidth			(Gstate, pt);
Error PFFlatness			(Gstate, pt);

Error PFCTMSave 			(Gstate);
Error PFCTMRestore			(Gstate);
Error PFCTMRestoreKeep		(Gstate);
Error PFCTMReset			(Gstate);
Error PFCTMSet				(Gstate, pt, pt, pt, pt, pt, pt);





Error PFPathMethod			(Gstate, int);
Error PFPathClose			(Gstate);
Error PFPathClear			(Gstate);
Error PFPathDraw			(Gstate);
Error PFPathClip			(Gstate);




Error PFMoveTo				(Gstate, pt, pt);
Error PFMoveR				(Gstate, pt, pt);
Error PFLineTo				(Gstate, pt, pt);
Error PFLineR				(Gstate, pt, pt);
Error PFCurveTo 			(Gstate, pt, pt, pt, pt, pt, pt);
Error PFCurveR				(Gstate, pt, pt, pt, pt, pt, pt);
Error PFArcTo				(Gstate, pt, pt, pt, pt);
Error PFArcR				(Gstate, pt, pt, pt, pt);
Error PFCircle				(Gstate, pt);
Error PFPie 				(Gstate, pt, pt, pt, pt, pt, char);
Error PFRectangle			(Gstate, pt, pt, pt);

Error PFPageClear			(Gstate);
Error PFPageShow			(Gstate);
Error PFPageScroll			(Gstate, pt, pt);
Error PFPageScale			(Gstate, pt);

Error PFPageBboxReset		(Gstate);
Error PFPageBboxRestore 	(Gstate);
Error PFPageBboxSet 		(Gstate, pt, pt, pt, pt);
Error PFPageBboxGet 		(Gstate, PageBbox *);
Error PFPageBboxFullGet 	(Gstate, Bbox *);
Error PFPageOriginSet		(Gstate, pt, pt);

Error PFClipClear			(Gstate);

Error PFFontScale			(Gstate, pt);
Error PFFontLoad			(Gstate, const char *);
Error PFFontNameGet 		(Gstate, char *);
Error PFFontWeightGet		(Gstate, char *);
Error PFFontFamilyGet		(Gstate, char *);
Error PFFontNoticeGet		(Gstate, char *);
Error PFFontVersionGet		(Gstate, char *);
Error PFFontUnLoad			(Gstate, const char *);
Error PFFontSelect			(Gstate, const char *);
Error PFFontBbox			(Gstate, Bbox *);
Error PFFontCalculate		(Gstate);

Error PFShow				(Gstate, const short *);
Error PFShowKern			(Gstate, const short *);
Error PFShowX				(Gstate, const short *, const pt *);
Error PFShowXY				(Gstate, const short *, const pt *, const pt *);
Error PFShowKernJust		(Gstate, const short *, pt);
Error PFShowJust			(Gstate, const short *, pt);
Error PFShowTrack			(Gstate, const short *, pt);

Error PFWidth				(Gstate, const short *, pt *);
Error PFWidthKern			(Gstate, const short *, pt *);

Error PFFontNext			(Gstate);
Error PFFontNextName		(Gstate, char *);
Error PFFontCount			(Gstate, int *);
Error PFFontCountAll		(Gstate, int *);

Error PFWindowSubRestore	(Gstate);
Error PFWindowSubSet		(Gstate, pt, pt, pt, pt);
Error PFBufferUpdate		(Gstate);
Error PFBufferSave			(Gstate);
Error PFBufferRestore		(Gstate);

Error PFDriverCount 		(Gstate, int *);
Error PFDriverNext			(Gstate, int *, char *);

Error PFCharAvailable		(Gstate, int);
Error PFCharPathInit		(Gstate, int);
Error PFCharPathEl			(Gstate, short *, pt *, pt *, pt *, pt *, pt *, pt *);

Error PFStringShow			(Gstate, const char *);
Error PFStringShowKern		(Gstate, const char *);
Error PFStringShowX 		(Gstate, const char *, const pt *);
Error PFStringShowXY		(Gstate, const char *, const pt *, const pt *);
Error PFStringShowKernJust	(Gstate, const char *, pt);
Error PFStringShowJust		(Gstate, const char *, pt);
Error PFStringShowTrack 	(Gstate, const char *, pt);

Error PFStringWidth 		(Gstate, const char *, pt *);
Error PFStringWidthKern 	(Gstate, const char *, pt *);

Error PFColourGray			(Gstate, pt);
Error PFColourRGB			(Gstate, const ColourRGB *);
Error PFColourCMYK			(Gstate, const ColourCMYK *);
Error PFPaperColourGray 	(Gstate, pt);
Error PFPaperColourRGB		(Gstate, const ColourRGB *);
Error PFPaperColourCMYK 	(Gstate, const ColourCMYK *);
Error PFPatternMask 		(Gstate, short);
Error PFPatternMaskUser 	(Gstate, const char *);

Error PFPrintEscape 		(Gstate, int);
Error PFExtraEOS			(Gstate, int);
Error PFCopies				(Gstate, int);
Error PFCacheUse			(Gstate, int);
Error PFDisplayMode 		(Gstate, int);

Error PFPictureCount		(Gstate, int *);
Error PFPictureNext 		(Gstate, int *, char *);
Error PFPictureRecognize	(Gstate, int, char *);
Error PFPictureRatio		(Gstate, int, char *, int *, int *);
Error PFPictureColourCount	(Gstate, int, char *, int *);
Error PFPictureColourGrayGet(Gstate, int, char *, pt *);
Error PFPictureColourRGBGet (Gstate, int, char *, ColourRGB *);
Error PFPictureColourCMYKGet(Gstate, int, char *, ColourCMYK *);
Error PFPictureDisplay		(Gstate, int, char *, pt, pt);
Error PFPictureDisplayGray	(Gstate, int, char *, pt, pt, pt *);
Error PFPictureDisplayRGB	(Gstate, int, char *, pt, pt, ColourRGB *);
Error PFPictureDisplayCMYK	(Gstate, int, char *, pt, pt, ColourCMYK *);

 

Error PFPGstateInit 		(int, const char *, const PBbox *, Gstate *, int *);
Error PFPGstateReAssign 	(Gstate, int, short, short, short, short);
Error PFPGstateReAssign2	(Gstate, int, char *, short, short, short, short);

Error PFPMoveTo 			(Gstate, pt, pt);
Error PFPMoveR				(Gstate, pt, pt);
Error PFPLineTo 			(Gstate, pt, pt);
Error PFPLineR				(Gstate, pt, pt);
Error PFPCurveTo			(Gstate, pt, pt, pt, pt, pt, pt);
Error PFPCurveR 			(Gstate, pt, pt, pt, pt, pt, pt);
Error PFPArcTo				(Gstate, pt, pt, pt, pt);
Error PFPArcR				(Gstate, pt, pt, pt, pt);
Error PFPRectangle			(Gstate, pt, pt);

Error PFPPageScroll 		(Gstate, short, short);

Error PFPPageBboxSet		(Gstate, short, short, short, short);
Error PFPPageBboxGet		(Gstate, PPageBbox *);
Error PFPPageBboxFullGet	(Gstate, PBbox *);
Error PFPPageOriginSet		(Gstate, short, short);

Error PFPShowX				(Gstate, const short *, const short *);
Error PFPShowXY 			(Gstate, const short *, const short *, const short *);
Error PFPStringShowX		(Gstate, const char *, const short *);
Error PFPStringShowXY		(Gstate, const char *, const short *, const short *);

Error PFPWindowMove 		(Gstate, short, short);
Error PFPWindowSubSet		(Gstate, short, short, short, short);

Error PFPShow				(Gstate, const short *);
Error PFPWidth				(Gstate, const short *, short *);
Error PFPStringShow 		(Gstate, const char *);
Error PFPStringWidth		(Gstate, const char *, short *);
Error PFPFontBbox			(Gstate, short, PBbox *);

Error PFPWindowLink 		(Gstate, Channel, short, short, short, short, short, short);


# 18 "ProWesS_h" 2



 

typedef struct _PWDummyObject *PWObject;
typedef unsigned long PWType;
typedef struct _PWTypeDef PWTypeDef;

 
Error PWCreate(PWObject owner, PWObject *ret, PWType type, ...);
Error PWDoCreate(PWObject owner, PWObject *ret, PWType type, int *taglist);
Error PWChange(PWObject object, ...);
Error PWDoChange(PWObject object, int *taglist);
Error PWQuery(PWObject object, int what, void *ret);
Error PWActivate(PWObject object);
Error PWAddType(PWTypeDef *newtype);
Error PWRemove(PWObject object);

 



 
 
 
 

 
 
 
 
 
 
 
 
 









 

















































 






# 1 "PWStdTags_h" 1
 











# 1 "pth1_include_win_h" 1



 








# 1 "pth1_include_io_h" 1
# 148 "pth1_include_io_h"

# 13 "pth1_include_win_h" 2


typedef Channel Window; 			 

typedef struct {
	short xsiz, ysiz, xpos, ypos;	 
	short xshadow, yshadow; 		 
	short border_colour, border_width;	 
	short paper_colour, draw_colour;	 
} WindowDescriptor;

typedef struct {
	short xsiz, ysiz;				 
	short xpos, ypos;				 
} WindowInfo;










typedef char WindowMode;			 


typedef struct _WindowArea {
	struct _WindowArea *next;		 
	unsigned short flag;			 
	short xsiz, ysiz;				 
	short line_increment;			 
	WindowMode mode;				 
	char zero;						 
	char data[2];					 
} WindowArea;

typedef struct {
	short form, adaption;
	short xsiz, ysiz;
	short xorg, yorg;
	char *rel_colour;				 
	char *rel_mask; 				 
	char *rel_next; 				 
} Sprite;

extern Sprite *SPRITE_ARROW;
extern Sprite *SPRITE_HAND;
extern Sprite *SPRITE_LEFT;
extern Sprite *SPRITE_MOVE;
extern Sprite *SPRITE_SIZE;
extern Sprite *SPRITE_SLEEP;
extern Sprite *SPRITE_WAKE;
extern Sprite *SPRITE_NULL;

typedef struct {
	short xsiz, ysiz;				 
	short xpos, ypos;				 
	char cursor, spare; 			 
	short border_width, border_colour, paper_colour;  
	Sprite *sprite; 				 
} SubWindow;

typedef struct {
	SubWindow **list;				 
									 
	SubWindow main; 				 
} SubWindowList;





















typedef unsigned long WindowEvent;	 

typedef struct {
	Window id;						 
	short subwindow;				 
	short xpos,ypos;				 
	char keystroke, keypress;		 
	WindowEvent event;				 
	WindowInfo sub; 				 
} PointerInfo;



















Error WINOpen(short xsiz, short ysiz, short xpos, short ypos, Window *id);
Error WINOpenFull(WindowDescriptor *descriptor, Window *id);
Error WINClose(Window);

Error WINGet(Window id, char *ret);
Error WINPut(Window id, char value);

Error WINPutString(Window id, char *string);


Error WINTest(Window id);


Error WINTimeOutSet(Window id, TimeOut t);

Error WINTimeOutGet(Window id, TimeOut *t);

Error WINPutStringAddNewLineGet(Window id, char *status);

Error WINPutStringAddNewLineSet(Window id, char status);


Error WINWindow(Window id, short xsiz, short ysiz, short xpos, short ypos);
Error WINBorder(Window id, short width, short colour);
Error WINRedefine(Window id, short width, short colour,
				  short xsiz, short ysiz, short xpos, short ypos);
Error WINPaper(Window id, short colour);
Error WINStrip(Window id, short colour);
Error WINInk(Window id, short colour);

Error WINClear(Window id);
Error WINClearTop(Window id);
Error WINClearBottom(Window id);
Error WINClearLine(Window id);
Error WINClearRight(Window id);

Error WINCursorEnable(Window id);
Error WINCursorDisable(Window id);
Error WINPendingNewLine(Window id);
Error WINNewLine(Window id);
Error WINColumnPrev(Window id);
Error WINColumnNext(Window id);
Error WINRowPrev(Window id);
Error WINRowNext(Window id);
Error WINCursorSize(Window id, short xsiz, short ysiz);
Error WINAtCursor(Window id, short xpos, short ypos);
Error WINAtColumn(Window id, short ypos);
Error WINAtPixel(Window id, short xpos, short ypos);

Error WINOverWrite(Window id, short status);
Error WINUnderLine(Window id, short status);

Error WINScroll(Window id, short distance);
Error WINScrollTop(Window id, short distance);
Error WINScrollBottom(Window id, short distance);
Error WINPan(Window id, short distance);
Error WINPanLine(Window id, short distance);
Error WINPanRight(Window id, short distance);

Error WINInfoCursor(Window id, WindowInfo *ret);
Error WINInfoPixel(Window id, WindowInfo *ret);

Error WINLimits(Window id, WindowInfo *ret);

Error WINBlock(Window id, short colour,
			   short xsiz, short ysiz, short xpos, short ypos);
Error WINSprite(Window id, short xpos, short ypos, Sprite *sprite);

Error WINAreaAllocate(short xsiz, short ysiz, WindowMode mode,
					  WindowArea **area);
Error WINAreaRelease(WindowArea *area);
Error WINAreaSave(Window id, WindowInfo *info, short xpos, short ypos,
				  WindowArea *area);
Error WINAreaRestore(Window id, WindowInfo *info, short xpos, short ypos,
				  WindowArea *area);
Error WINMode(WindowMode *mode);

Error WINPointerRead(Window id, TimeOut timeout, WindowEvent event,
					 short *xpos, short *ypos, PointerInfo *pinfo);
Error WINOutline(Window id, short xshadow, short yshadow,
				 short xsiz, short ysiz, short xpos, short ypos);
Error WINMove(Window id, short xpos, short ypos);
Error WINSubWindows(Window id, SubWindowList *subwindows);

Error WINPointerPositionSet(Window id, short xpos, short ypos);
Error WINPointerPositionGet(Window id, short *xpos, short *ypos);
Error WINPointerLimits(Window id, short xorg, short yorg, short xend, short yend);

Error WINEventSend(Job job, WindowEvent event);
Error WINEventWait(TimeOut timeout, WindowEvent *event);


# 13 "PWStdTags_h" 2






































































































































































































































 

























 
typedef struct {
	pt xorg, yorg;					 
									 
									 
	pt xsiz, ysiz;					 
	pt xpos, ypos;					 
	Gstate gstate;					 
									 
	short xpixsiz, ypixsiz; 		 
	short xpixorg, ypixorg; 		 
	short xpixpos, ypixpos; 		 
	Window window;					 
									 
	pt Xpix2pt, Ypix2pt;			 
	pt Xpt2pix, Ypt2pix;			 
	short zero; 					 
} CanvasInfo;

 
typedef struct {
	int maxlength;					 
	char *string;					 
	int length; 					 
	int cursor; 					 
	char key;						 
} EdlineInfo;
# 121 "ProWesS_h" 2



# 15 "PWHandler_h" 2



# 1 "PWObject_h" 1



 









# 1 "pth1_include_err_h" 1
# 51 "pth1_include_err_h"

# 14 "PWObject_h" 2


 

typedef struct _PWSystem PWSystem;
typedef union {
	struct _PWRegion *region;		 
	struct _PWKeyPress *keypress;	 
} PWEvent;

 













struct _PWDummyObject {
	PWTypeDef *type;	PWEvent event;	void *auxiliary;	short status					;					 
};


# 18 "PWHandler_h" 2



# 1 "PWSystem_h" 1



 










# 1 "pth1_include_mem_h" 1
# 51 "pth1_include_mem_h"

# 15 "PWSystem_h" 2

# 1 "pth1_include_win_h" 1
# 223 "pth1_include_win_h"

# 16 "PWSystem_h" 2

# 1 "pth1_include_job_h" 1



 








# 1 "pth1_include_io_h" 1
# 148 "pth1_include_io_h"

# 13 "pth1_include_job_h" 2

# 1 "pth1_include_win_h" 1
# 223 "pth1_include_win_h"

# 14 "pth1_include_job_h" 2




typedef signed char Priority;	 




Error JOBMe(Job *result);
Error JOBTree(Job treetop, Job *scan);
Error JOBInfo(Job job, char *name, char *suspended, Priority *priority);

Error JOBActivate(Job job, Priority priority);
Error JOBActivateWait(Job job, Priority priority);
Error JOBWait(Job job, TimeOut timeout);
Error JOBCreate(Job owner, Size code, Size data, void *start, Job *id, void **base);
Error JOBZap(Job job, Error error);
Error JOBRemove(Job job, Error error);
Error JOBPriority(Job job, Priority priority);
Error JOBUnSuspend(Job job);
Error JOBSuspend(Job job, TimeOut timeout, char *flag);

Error JOBCall(Error (*rout)(), char *name, Priority priority, Size stackspace,
		Job *jobid, int paramcount, ...);
Error JOBLoad(char *name, char *path, Priority priority, Job owner, char wait,
		int stringcount, char **strings, int channelcount, Channel *channels,
		Job *jobid);

Error JOBPick(Job job);
Error JOBWake(Job job);

Error JOBEventSend(Job job, WindowEvent event);

Error WinEventWait(TimeOut timeout, WindowEvent *event);



# 17 "PWSystem_h" 2



# 1 "PWEvent_h" 1



 










# 1 "pth1_include_io_h" 1
# 148 "pth1_include_io_h"

# 15 "PWEvent_h" 2





typedef unsigned char Scale;		 
typedef int pix;					 







						  







typedef short PWWait;				 


struct _PWRegion {
	PWSystem *system;				 
	PWObject parentObject;			 
	PWObject owner; 				 
	struct _PWRegion *parent;		 
	struct _PWRegion *next; 		 
	struct _PWRegion *prev; 		 
	struct _PWRegion *children; 	 
	short level;					 

	PWWait wait_event;				 
	TimeOut timeout;				 
									 
	pt tot_xpos, tot_ypos;			 
	pt tot_xsiz, tot_ysiz;			 
									 
									 
	pix hit_off_lft, hit_off_rgt;	 
	pix hit_off_top, hit_off_bot;	 
	pix hit_xorg, hit_yorg; 		 
	pix hit_xend, hit_yend; 		 
									 
									 
									 
	Scale scale;					 
	char windowfit; 				 
	char composite; 				 
	char dragging;					 
};

struct _PWKeyPress {
	PWSystem *system;				 
	PWObject parentObject;			 
	PWObject owner; 				 
	struct _PWKeyPress *next;		 
	char key;						 
	char alternative;				 
};

typedef struct _PWRegion PWRegion;
typedef struct _PWKeyPress PWKeyPress;


# 20 "PWSystem_h" 2



 
 
 





typedef struct _PWDummyTypeState {
	PWType type;	struct _PWDummyTypeState *next	;				 
} PWDummyTypeState;

 


# 55 "PWSystem_h"


struct _PWSystem {
	unsigned long status;	Gstate gstate;	Window window;	PWObject catchkeys; char catch; char activated; short ptr_xpos, ptr_ypos;	pix win_xpos, win_ypos; pix xorg, yorg; Heap heap;	int Xdragadjust, Ydragadjust;	int Xspaceleft, Yspaceleft		;
};







# 21 "PWHandler_h" 2



# 1 "PWTypeDef_h" 1



 









# 1 "PWEvent_h" 1
# 82 "PWEvent_h"

# 14 "PWTypeDef_h" 2









typedef struct _PWTypeDef {
	int flag;						 

	PWType identifier;				 

	char event_type;				 
									 

	 
	Error (*PWCreate)(PWObject owner, PWObject *ret, PWEvent event, int *taglist);
	Error (*PWChange)(PWObject object, int *taglist);
	Error (*PWQuery)(PWObject object, int what, void *ret);
	Error (*PWRemove)(PWObject object);

	 
	Error (*PWRegionEntry)(PWObject object);
	Error (*PWRegionExit)(PWObject object);
	Error (*PWHandle)(PWObject object, PWWait event);

	 
	Error (*PWDefine)(char *name, char *value);

	 
	 

	Error (*PWDraw)(PWObject object);

	 
	Error (*PWDetermineSize)(PWObject object);
	Error (*PWScale)(PWObject object, pt xinc, pt yinc);
};


# 24 "PWHandler_h" 2



Error PWHandleKeyPress(PWSystem *system);
Error PWGetType(PWType type, PWTypeDef **rettype);
int *PWSkipTag(int *taglist);
Error PWAllocate(PWSystem *system, Size size, void **ret);
Error PWRelease(PWObject object, void *base);

void PWpixel2point(pt *xfactor, pt *yfactor);
void PWpoint2pixel(pt *xfactor, pt *yfactor);
int PF2xpix(pt x);
int PF2ypix(pt x);
pt xpix2PF(short x);
pt ypix2PF(short x);
pt PFxround(pt x);
pt PFyround(pt x);

typedef struct _Defines {
	char *name; 					 
	Error (*Handle)(struct _Defines *possible, char *value);
	void (*Post)(void *data);		 
	void *data; 					 
	char *set;						 
} Defines;









Error PWHandleDefine(char *prefix, Defines *possible, char *name, char *value);


# 17 "type_colselect_c" 2





 

typedef struct {
	PWTypeDef *type;	PWEvent event;	void *auxiliary;	short status					;
	PWObject outl, list, colbox, compbox;
	PWObject butgray, butrgb, butcmyk;
	PWObject comp1, comp2, comp3, comp4;
	int colourtype;
	ColourRGB rgb;
	ColourCMYK cmyk;
	pt gray;
} Object;

 

Error Create(PWObject owner, PWObject *ret, PWEvent event, int *taglist)
{
	 
	return PWAllocate(event.region->system,sizeof(Object),ret);
}

Error Remove(PWObject object)
{
	Object *obj=(Object *)object;

	if (obj->outl)
		PWRemove(obj->outl);
	return PWRelease((PWObject)obj,(PWObject)obj);
}

Error Handle(PWObject object, PWWait event)
{
	Object *obj=(Object *)object;
	char dir[50			];
	Error err;

	PWChange(obj->outl,(0x020 +((0x10+0)<<24) ) ,0 );
	err=PWActivate(obj->outl);
	return err;
}

Error exit(PWObject object)
{
	return PWChange(object,	(0x009 +((0x10+0)<<24) ) ,0 );
}

Error redrawPreview(PWObject object, CanvasInfo *rinfo)
{
	int i,j,siz;
	Gstate gid=rinfo->gstate;
	Object *obj;

	PWQuery(object,	(0x008 +((0x10+1)<<24) ) ,&obj);

	 
	switch (obj->colourtype)
	{
	case 1 :
		PFPaperColourGray(gid,obj->gray);
		break;
	case 	2 :
		PFPaperColourRGB(gid,obj->rgb);
		break;
	case 3 :
		PFPaperColourCMYK(gid,obj->cmyk);
		break;
	}
	return PFPageClear(gid);	 
}

Error gray(PWObject object) {
	Object *obj;
	PWQuery(object,	(0x008 +((0x10+1)<<24) ) ,&obj);

	PWChange(object, (0x003 +((0x10+1)<<24) +	0x00001000	) , 	1 );

	if (obj->type!=1 ) {
		PWChange(obj->butcmyk, (0x003 +((0x10+1)<<24) +	0x00001000	) , 	1 );
		PWChange(obj->butrgb, (0x003 +((0x10+1)<<24) +	0x00001000	) , 	1 );
		 
	}
	return 		  0 	;
}
Error rgb(PWObject object) {
	Object *obj;
	PWQuery(object,	(0x008 +((0x10+1)<<24) ) ,&obj);

	PWChange(object, (0x003 +((0x10+1)<<24) +	0x00001000	) , 	1 );

	if (obj->type!=1 ) {
		PWChange(obj->butcmyk, (0x003 +((0x10+1)<<24) +	0x00001000	) , 	1 );
		PWChange(obj->butgray, (0x003 +((0x10+1)<<24) +	0x00001000	) , 	1 );
		 
	}
	return 		  0 	;
}
Error cmyk(PWObject object) {
	Object *obj;
	PWQuery(object,	(0x008 +((0x10+1)<<24) ) ,&obj);

	PWChange(object, (0x003 +((0x10+1)<<24) +	0x00001000	) , 	1 );

	if (obj->type!=1 ) {
		PWChange(obj->butgray, (0x003 +((0x10+1)<<24) +	0x00001000	) , 	1 );
		PWChange(obj->butrgb, (0x003 +((0x10+1)<<24) +	0x00001000	) , 	1 );
		 
	}
	return 		  0 	;
}
Error preview(PWObject object)
{
	 
	 
}

Error Change(PWObject object, int *taglist)
{
	Object *obj=(Object *)object;
	PWSystem *system=obj->event.region->system;
	Error err=		  0 	;
	char unrecognised_tag=0 ;

	if (!(obj->status&(short)0x0004	))
	{
		PWObject box;
		List *dev;

		obj->status|=(short)0x0004	;

		 
		do { if (err=( PWCreate(0 ,&obj->outl,			0x4f55544c ,
								(0x022 +((0x10+0)<<24) +	0x00001000	) ,
						(0x025+((0x10+1)<<24) +	0x00001000	) , 27,
							(0x008 +((0x10+1)<<24) ) , obj,
						(0x02d +((0x10+1)<<24) +	0x00001000	) , "colour select",
						0 ) )) return err; } while (0) ;

		 
		do { if (err=( PWCreate(obj->outl,&box,		0x4b454550 ,
								(0x00c +((0x10+1)<<24) ) , 0,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(box,0 ,			0x4c41424c ,
								(0x0a0 +((0x10+1)<<24) +	0x00001000	) , "preview",
								(0x00c +((0x10+1)<<24) ) , 0,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(box,&obj->preview,			0x43414e56 ,
						(0x052 +((0x10+1)<<24) +	0x00001000	) , &redrawPreview,
							(0x055 +((0x10+1)<<24) +	0x00001000	) , SPRITE_HAND,
						0 ) )) return err; } while (0) ;

		 
		do { if (err=( PWCreate(obj->outl,&box,		0x4b454550 ,
								(0x00c +((0x10+1)<<24) ) , 0,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(box,&obj->butgray,		0x4c4f4f53 ,
							(0x007 +((0x10+1)<<24) +	0x00001000	) , &gray,
								(0x002 +((0x10+1)<<24) +	0x00001000	) , "Gray",
							(0x006 +((0x10+1)<<24) +	0x00001000	) , 'g',
								(0x00c +((0x10+1)<<24) ) , 0,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(box,&obj->butrgb,		0x4c4f4f53 ,
							(0x007 +((0x10+1)<<24) +	0x00001000	) , &rgb,
								(0x002 +((0x10+1)<<24) +	0x00001000	) , "RGB",
							(0x006 +((0x10+1)<<24) +	0x00001000	) , 'r',
								(0x00c +((0x10+1)<<24) ) , 0,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(box,&obj->butcmyk,		0x4c4f4f53 ,
							(0x007 +((0x10+1)<<24) +	0x00001000	) , &cmyk,
								(0x002 +((0x10+1)<<24) +	0x00001000	) , "CMYK",
							(0x006 +((0x10+1)<<24) +	0x00001000	) , 'c',
								(0x00c +((0x10+1)<<24) ) , 0,
						0 ) )) return err; } while (0) ;

		 
		do { if (err=( PWCreate(obj->outl,&obj->colbox,		0x4b454550 ,
								(0x00c +((0x10+1)<<24) ) , 0,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(obj->colbox,&obj->compbox,		0x4b454550 ,
								(0x00c +((0x10+1)<<24) ) , 0,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(obj->compbox,&obj->comp1,			0x45444c49 ,
							(0x0b0 +((0x10+1)<<24) +	0x00001000	) , 10,
							(0x0b6 +((0x10+1)<<24) +	0x00001000	) , '1',
						(0x0b7 +((0x10+1)<<24) +	0x00001000	) , &preview,
							(0x0b5 +((0x10+1)<<24) +	0x00001000	) , 	((pt)(12)<<16) ,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(obj->compbox,&obj->comp2,			0x45444c49 ,
							(0x0b0 +((0x10+1)<<24) +	0x00001000	) , 10,
							(0x0b6 +((0x10+1)<<24) +	0x00001000	) , '2',
						(0x0b7 +((0x10+1)<<24) +	0x00001000	) , &preview,
							(0x0b5 +((0x10+1)<<24) +	0x00001000	) , 	((pt)(12)<<16) ,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(obj->compbox,&obj->comp3,			0x45444c49 ,
							(0x0b0 +((0x10+1)<<24) +	0x00001000	) , 10,
							(0x0b6 +((0x10+1)<<24) +	0x00001000	) , '3',
						(0x0b7 +((0x10+1)<<24) +	0x00001000	) , &preview,
							(0x0b5 +((0x10+1)<<24) +	0x00001000	) , 	((pt)(12)<<16) ,
						0 ) )) return err; } while (0) ;
		do { if (err=( PWCreate(obj->compbox,&obj->comp3,			0x45444c49 ,
							(0x0b0 +((0x10+1)<<24) +	0x00001000	) , 10,
							(0x0b6 +((0x10+1)<<24) +	0x00001000	) , '3',
						(0x0b7 +((0x10+1)<<24) +	0x00001000	) , &preview,
							(0x0b5 +((0x10+1)<<24) +	0x00001000	) , 	((pt)(12)<<16) ,
						0 ) )) return err; } while (0) ;
	}

	while (*taglist)
	{
		switch (*taglist)
		{
		case 	(0x110 +((0x10+1)<<24) +	0x00001000	) :
			PWChange(obj->dir,		(0x0b1 +((0x10+1)<<24) +	0x00001000	) ,(char *)(*(taglist+1)),0 );
			break;
		case (0x111 +((0x10+1)<<24) +	0x00001000	) :
			PWChange(obj->outl,(0x02d +((0x10+1)<<24) +	0x00001000	) ,(char *)(*(taglist+1)),0 );
			break;
		case (0x112 +((0x10+0)<<24) +	0x00001000	) :
			Handle(object,0);
			break;
		case 	(0x113 +((0x10+1)<<24) +	0x00001000	) :
			obj->After=(Error (*)(PWObject,char *))(*(taglist+1));
			break;
		case 	(0x114 +((0x10+2)<<24) +	0x00001000	) :
			PWChange(obj->dir,		(0x0b2 +((0x10+2)<<24) +	0x00001000	) ,(*(taglist+1)),(*(taglist+2)),0 );
			break;
		default :
			if (*taglist&(~		0xff000000	))
				unrecognised_tag=-1 ;
			break;
		}
		taglist=PWSkipTag(taglist);
	}
	if (unrecognised_tag) err=	-15 	;
	return err;
}

Error Define(char *name, char *value)
{
	List *link, *new;
	Error err;

	if (MEMSame(strlen(name)+1,name,"DIRSELECT-DEVICE") )
	{
		link=&devices;
linkname:
		do { if (err=( MEMAllocate(sizeof(List)-1+strlen(value),&new) )) return err; } while (0) ;
		STRCopy(value,new->name);
		while (link->next) link=link->next;
		link->next=new;
		return 		  0 	;
	}
	if (MEMSame(strlen(name)+1,name,"DIRSELECT-DIRECTORY") )
	{
		link=&directories;
		goto linkname;
	}
	return 	-15 	;
}

PWTypeDef init={
	0x58505753	, 	0x4353454c  , 2	,
	&Create, &Change, 0 , &Remove, 0 , 0 , &Handle, &Define,
	0 , 0 , 0 
};
